unit Mouse;

{$A+,B-,D+,E-,F+,G+,I-,L+,N-,O+,P-,Q-,R-,S-,T-,V-,X+,Y+}

interface

uses crt,dos;

var
  LMbutton, MMbutton, RMbutton, MouseActive, boMouseOn : boolean;
  NumButtons, Buttons : byte;
  MouseX, MouseY : word;

procedure  MouseGet(pbo:boolean);
procedure  MouseGetT(pbo:boolean);
procedure  MouseInit;
procedure  MouseOff;
procedure  MouseOn;
procedure  MousePut(mx,my:word);
procedure  MouseWindow(lx,by,rx,oy:word);

implementation

var
  regs : registers;


{$F+}


procedure MouseGet(pbo:boolean);
begin
  if (not MouseActive) then exit;

  LMbutton:=false; MMbutton:=false; RMbutton:=false;
  repeat
   regs.AX:=$3;
   intr($33,regs);
   MouseX:=regs.CX;
   MouseY:=regs.DX;
   Buttons:=regs.BL and 7;
  until (pbo or (Buttons<>0));
  if Buttons and 1=1 then LMbutton:=true;
  if Buttons and 2=2 then RMbutton:=true;
  if Buttons and 4=4 then MMbutton:=true;
end;


procedure MouseGetT(pbo:boolean);
begin
  if (not MouseActive) then exit;

  MouseGet(pbo);
  if lastmode=7 then MouseX:=(MouseX div 9)+1 else MouseX:=(MouseX div 8)+1;
  if lastmode=7 then MouseY:=(MouseX div 14)+1 else MouseY:=(MouseY div 8)+1;
end;


procedure MouseInit;
begin
  regs.ax:=$0;
  intr($33,regs);
  MouseActive := (regs.AX <> $FFFF);
  NumButtons := regs.BL;
  MouseX:=0;
  MouseY:=0;
  Buttons:=0;
end;


procedure MouseOff;
begin
  if (not MouseActive) then exit;

  regs.AX:=2;
  intr($33,regs);
  boMouseOn:=false;
end;


procedure MouseOn;
begin
  if (not MouseActive) then exit;

  regs.AX:=1;
  intr($33,regs);
  boMouseOn:=true
end;


procedure MousePut(mx,my:word);
begin
  if (not MouseActive) then exit;

  regs.AX:=4;
  regs.CX:=mx;
  regs.DX:=my;
  intr($33,regs);
end;


procedure MouseWindow(lx,by,rx,oy:word);
begin
  if (not MouseActive) then exit;

  regs.AX:=7;
  regs.CX:=lx;
  regs.dX:=rx;
  intr($33,regs);

  regs.AX:=8;
  regs.CX:=oy;
  regs.DX:=by;
  intr($33,regs);
end;


end.